<?php
/*
 * Created on 9 Aug 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 */

$title="Network Settings"; 
$tabs=array("Basic","Advanced");

include ("prolog.php");

include 'safe-data.php';

$conf=new ipconfig;
$conf->load();
$dns=new dnsconfig;
$dns->load();
$modem=new modemconfig;
$modem->load();


//parse_str($_GET,$input);
$mod=0;
$moddns=0;

$reboot=0;
$query=0;
$reboot=false;
$pinreset=false;
$reason = "";

if (isset($_POST["updateNetConf"])) {
	$vals=array("netiface", "dhcp", "address", "netmask", "gateway", "hostname" );
	foreach ($vals as $name){
		if (!isset($_POST[$name])) $_POST[$name]=""; 
		if ($conf->$name!=$_POST[$name]) {
			$mod=1; 
			$conf->$name=$_POST[$name];	
		}
	}
	$vals=array("nameserver1","nameserver2","nameserver3", "search", "domain" );
	foreach ($vals as $name){
		if (!isset($_POST[$name])) $_POST[$name]=""; 
		if ($dns->$name!=$_POST[$name]) {
			$moddns=1; 
			$dns->$name=$_POST[$name];
		}
	}
	$modem->setSimple($_POST["interfacemode"]=="simple");
	$vals=modemconfig::getFormNames();
	foreach ($vals as $name){
        $modem->setField($name, isset($_POST[$name]) ? $_POST[$name] : '');
	}
	
	if (isset($_POST["reboot"])) {
		$reboot=true;
		$reason = "user forced reboot";
	}
	
	$allOK=true;
    if ($allOK && $modem->isPINBlocked() && $modem->getField('puk')) {
        $pinreset = $modem->resetPIN();
        $allOK = $pinreset;
    }
	if ($mod && $allOK) {
		if ($conf->netiface == ipconfig::NET_MODEM && $modem->isChanged())
			$allOK = $modem->check();
		if ($allOK) $allOK=$conf->save();
	}
	if ($modem->isChanged() && $allOK) $allOK=$modem->save();
	if ($moddns && $allOK) $allOK=$dns->save();
	
	if ( $allOK && ($mod || $moddns || $modem->isChanged() || $pinreset) ) {
		$reboot=true;
		$reason = "network config change (" . $conf->netiface . ", " .
			($conf->netiface == ipconfig::NET_MODEM ? "automatic IP" :
			 ($conf->dhcp ? "DHCP" : $conf->address)) . ")";
        if ($pinreset)
            $reason .= "; modem PIN reset";
	}
}

$snmpfile='/etc/snmp/snmpd.local.conf';
$snmpconf=file_get_contents($snmpfile);
$comunity="";
$access='local';

if (isset($_POST['rocommunity']) && isset($_POST['updateSNMP'])){
	$comunity=$_POST['rocommunity'];
	# NOTE: we set rocommunity and rocommunity6
	
	$addr="default";
	$snmpaddress="";
	if ($_POST['access']=="all"){
		$snmpconf=preg_replace("@^\s*agentaddress\s+\S+.*@m","agentaddress udp:161,tcp:161,udp6:161,tcp6:161",$snmpconf);
	} elseif ($_POST['access']=="limited") {
		$snmpconf=preg_replace("@^\s*agentaddress\s+\S+.*@m","agentaddress udp:161,tcp:161",$snmpconf);
		$snmpaddress = $addr = $_POST['snmpaddress'];
		//if ( preg_match("@^\s*(\d{1-3}\.\d{1-3}\.\d{1-3}\.\d{1-3})(/(\d{1-2}|\d{1-3}\.\d{1-3}\.\d{1-3}\.\d{1-3})|)\s*$@",$addr, $matches)!=0 && count($matches)>=2){
		if ( preg_match("@^\s*([\d\.]*)(/([\d\.]*)|)\s*$@",$addr, $matches)!=0 && count($matches)>=2){
			if ( !ip_check($matches[1]) || $matches[1]=="127.0.0.1" ){
				echo "<p style='color:red'>Warning: IP used in SNMP address range is not valid<p>";	
				$addr="";
			}
			if ( count($matches)>3 ) {
				if ( strpos($matches[3],'.')===false ){
					$val = intval( $matches[3] );
					if ( $val<=0 || $val>32 ){
						echo "<p style='color:red'>Warning: Mask used in SNMP address range is not valid (must be between 1 and 32)<p>";	
						$addr="";
					}
				}
				if ( strpos($matches[3],'.')!==false && !netmask_check($matches[3]) ){
					echo "<p style='color:red'>Warning: Mask used in SNMP address range is not valid<p>";	
					$addr="";
				}
				if ( !netaddr_check($matches[1], $matches[3] ) ){
					echo "<p style='color:red'>Warning: IP and Mask used in SNMP address range are not valid (address must end with 0)<p>";	
					$addr="";
				}
			}
		}else {
			echo "<p style='color:red'>Warning: SNMP address range is not valid<p>";	
			$addr="";
		}
	} else {
		$snmpconf=preg_replace("@^\s*agentaddress\s+\S+.*@m","agentaddress udp:127.0.0.1:161",$snmpconf);
	}
	if ( strpos($comunity," ")!==false ) {
		echo "<p style='color:red'>Warning: SNMP comunity cannot contain spaces<p>";
	}elseif ( !empty($addr) ) {
		$snmpconf=preg_replace("@^\s*rocommunity\s+\S+\s+127\.0\.0\.1.*@m","rocommunity $comunity 127.0.0.1",$snmpconf);
		$snmpconf=preg_replace("@^\s*rocommunity\s+\S+\s+(?!127\.0\.0\.1).*@m","rocommunity $comunity $addr",$snmpconf);
		$snmpconf=preg_replace("@^\s*rocommunity6\s+\S+.*@m","rocommunity6 $comunity default",$snmpconf);
		if ( save_file($snmpfile,$snmpconf) ) {
			$reboot=true; 	
			$reason = "snmp config change (" . $comunity .")";
		}
	}
}
if (preg_match("@^\s*agentaddress\s+(\S+)@m",$snmpconf,$matches)){
	if ($matches[1]=="udp:127.0.0.1:161")
		$access="local";
	elseif ($matches[1]=="udp:161,tcp:161") {
		$access="limited";
	}elseif ($matches[1]=="udp:161,tcp:161,udp6:161,tcp6:161")
		$access="all";
	
		
}
if (preg_match("@^\s*rocommunity\s+(\S+)\s+(\S+)+@m",$snmpconf,$matches)){
	$comunity=$matches[1];
	
	if ( $matches[2]!='default' && $matches[2]!='127.0.0.1' ) {
		$snmpaddress = $matches[2]; 
	} else if ($matches[2]=='127.0.0.1') {
		if ( preg_match("@^(\s*rocommunity\s+(\S+)\s+(\S+)+)+@m",$snmpconf,$matches)){
			if ( $matches[3]!='default' && $matches[3]!='127.0.0.1' )
				$snmpaddress = $matches[3]; 
		}
	} 
}

#
# Network watchdog
#

$nwfile='/etc/default/ifwatchdog';
$nwMaxTimeNoAddr = secs_to_timestr(0);
$nwMinTimeKeepAddr = secs_to_timestr(0);
$nwTimes = array('nwMaxTimeNoAddr' => 'MAX_TIME_NO_ADDR',
		 'nwMinTimeKeepAddr' => 'MIN_TIME_KEEP_ADDR');
if (isset($_POST['updateNetWatchdog'])) {
     $nwconf=file_get_contents($nwfile);
     $changed = FALSE;
     foreach ($nwTimes as $var => $nwItem) {
	  if(isset($_POST[$var])) {
	       $t = timestr_to_secs($_POST[$var]);
	       if ( $t < 0 )
		    $t = 0;
	       $changed = TRUE;
	       $nwconf = preg_replace("/^\s*#?\s*$nwItem=.*/m", "$nwItem=$t", $nwconf, -1, $count);
	       if ( $count == 0 )
		    $nwconf .= "\n$nwItem=$t\n";
	  }
     }
     if ($changed) {
	  save_file($nwfile, $nwconf);
	  $reboot = TRUE;
	  $reason = 'Network watchdog settings change';
     }
}
// we re-read the config file to be sure we show the saved values
$nwconf=file_get_contents($nwfile);
foreach ($nwTimes as $var => $nwItem) {
     if (preg_match("/^\s*$nwItem=(\d+)/m", $nwconf, $matches)) {
	  $$var = secs_to_timestr($matches[1]);
     } else {
	  $$var = secs_to_timestr(0);
     }
}

#
# Player related configuration
#

$xlinkNS = 'http://www.w3.org/1999/xlink';

$config_name="/etc/raperca/spxconfig.xml";
//$config_name="../config.xml";
$spxconf=file_get_contents($config_name);
$deviceName="";
$screenId="";
$remoteClientsEnabled="false";
$sharedVarPort=1234;
$proxyServer="";
$proxyPort="";
$proxyUser="";
$proxyPass="";
$bypassProxy=true;
$proxyFile = "/etc/network/spxproxy.conf";

if ($spxconf) {
	$domdoc = new DOMDocument;
	$domdoc->loadXML($spxconf);
	$multiscreen=$domdoc->getElementsByTagName("multiscreen");
	if ($multiscreen->length==1){
		$multiscreen=$multiscreen->item(0);
		if ($multiscreen->hasAttribute("screenId")) $screenId=$multiscreen->getAttribute("screenId");
	}else unset($multiscreen);
	$reporting=$domdoc->getElementsByTagName("reporting");
	if ($reporting->length==1){
		$reporting=$reporting->item(0);
		if ($reporting->hasAttribute("deviceName")) $deviceName=$reporting->getAttribute("deviceName");
	}else unset($reporting);
	$interactivity=$domdoc->getElementsByTagName("interactivity");
	if ($interactivity->length==1){
		$interactivity=$interactivity->item(0);
		if ($interactivity->hasAttribute("remoteClientsEnabled")) $remoteClientsEnabled=$interactivity->getAttribute("remoteClientsEnabled");
		if ($interactivity->hasAttribute("sharedVarPort")) $sharedVarPort=$interactivity->getAttribute("sharedVarPort");
	}else unset($interactivity);
	$proxyURI=$domdoc->getElementsByTagName("proxy");
	if ($proxyURI->length==1){
		$proxyURI=$proxyURI->item(0);
	}else unset($proxyURI);
	
	$proxydoc = new DOMDocument;
	if ( file_exists($proxyFile) ) {
		
		$proxydoc->loadXML(file_get_contents($proxyFile));
		$proxy=$proxydoc->getElementsByTagName('proxy');
		if ($proxy->length>0){
			$proxy=$proxy->item(0);
			if ($proxy->hasAttribute("server")) $proxyServer=$proxy->getAttribute("server");
			if ($proxy->hasAttribute("port")) $proxyPort=$proxy->getAttribute("port");	
			if ($proxy->hasAttribute("username")) $proxyUser=$proxy->getAttribute("username");
			if ($proxy->hasAttribute("password")) $proxyPass=$proxy->getAttribute("password");
			if ($proxy->hasAttribute("bypassLocalNetwork")) $bypassProxy=$proxy->getAttribute("bypassLocalNetwork")=="true";
			
			if ($proxyServer!="" && $proxyPort=="")
				$proxyPort="8080";
		} else unset($proxy);
	}
	
	
	if (isset($_POST['applyNames'])) {
		$deviceName = $_POST['deviceName'];
		$screenId = $_POST['screenId'];
		if ( preg_match('/[^\w\d-]/', $deviceName) || count($deviceName)>63 || $deviceName[0]=="-" || $deviceName[count($deviceName)-1]=="-" ) {
			echo "<p style='color:red'>Warning: Device name ('$deviceName') is not valid. The name may contain only ASCII letters, digits and the hyphen</p>";
			$deviceName="";
		}
		
		$player = $domdoc->getElementsByTagName("player");
		if ($player->length==0){
			$player = $domdoc->createElement("player");
			$domdoc->documentElement->appendChild($player);
		} else $player=$player->item(0);
		if (!isset($multiscreen)){
			$multiscreen = $domdoc->createElement("multiscreen");
			$player->appendChild($multiscreen);
		} 
		if (!isset($reporting)){
			$reporting = $domdoc->createElement("reporting");
			$player->appendChild($reporting);
		}
		
		if ($serial!=$deviceName)
			$reporting->setAttribute("deviceName",$deviceName);
		else
			$reporting->setAttribute("deviceName", "");		
		if ($serial!=$screenId)
			$multiscreen->setAttribute("screenId", $screenId);
		else
			$multiscreen->setAttribute("screenId", "");
		
		save_file($config_name,$domdoc->saveXML());	
		reconfig_player();
		reload_mdns();
		if ( ! setSafeModeData("devname", $deviceName, FALSE) )
		    echo "<p style='color:red'>Failed saving device name for recovery console, please try again.</p>";
	}	
	if (isset($_POST['updateAPI'])) {
		if (isset($_POST['remoteClientsEnabled'])) $remoteClientsEnabled="true";
		else $remoteClientsEnabled="false";
		if (isset($_POST['sharedVarPort']) && $_POST['sharedVarPort']!="") $sharedVarPort=$_POST['sharedVarPort'];
		$player = $domdoc->getElementsByTagName("player");
		if ($player->length==0){
			$player = $domdoc->createElement("player");
			$domdoc->documentElement->appendChild($player);
		} else $player=$player->item(0);
		if (!isset($interactivity)){
			$interactivity = $domdoc->createElement("interactivity");
			$player->appendChild($interactivity);
		} 
		$interactivity->setAttribute("remoteClientsEnabled", $remoteClientsEnabled);
		$interactivity->setAttribute("sharedVarPort", $sharedVarPort);
		
		save_file($config_name,$domdoc->saveXML());
		reconfig_player();
		reload_mdns();
	}
	if (isset($_POST['updateProxy'])) {
		if (isset($_POST['proxyServer'])) $proxyServer=$_POST['proxyServer'];
		else $proxyServer="";
		if (isset($_POST['proxyPort']) && $_POST['proxyPort']!="" ) $proxyPort=$_POST['proxyPort'];
		else $proxyPort="8080";
		if (isset($_POST['proxyUser']) && $_POST['proxyUser']!="" ) $proxyUser=$_POST['proxyUser'];
		if (isset($_POST['proxyPass']) && $_POST['proxyPass']!="" ) $proxyPass=$_POST['proxyPass'];
		if ( isset($_POST['bypassProxy']) )  $bypassProxy=true; else $bypassProxy=false;
		
		if ( $proxyServer=="" ) {
			$proxyPort="";
			$proxyUser="";
			$proxyPass="";	
		}
		
		$resource = $domdoc->getElementsByTagName("resource");
		if ($resource->length==0){
			$resource = $domdoc->createElement("resource");
			$domdoc->documentElement->appendChild($resource);
		} else $resource=$resource->item(0);
		if (!isset($proxyURI)){
			$proxyURI = $domdoc->createElement("proxy");
			$resource->appendChild($proxyURI);
		} 
		$proxyURI->setAttributeNS($xlinkNS,"xlink:href", $proxyFile);
		
		$proxyconf = $proxydoc->getElementsByTagName("proxyconf");
		if ($proxyconf->length==0){
			$proxyconf = $proxydoc->createElement("proxyconf");
			$proxydoc->appendChild($proxyconf);
		} else $proxyconf=$proxyconf->item(0);
		if ( $proxyServer!="" ) {
			if (!isset($proxy)){
				$proxy = $proxydoc->createElement("proxy");
				$proxyconf->appendChild($proxy);
			} 
			$proxy->setAttribute("server", $proxyServer);
			$proxy->setAttribute("port", $proxyPort);
			$proxy->setAttribute("bypassLocalNetwork", $bypassProxy?"true":"false");
			if ($proxyUser!="") {
				$proxy->setAttribute("username", $proxyUser);	
				$proxy->setAttribute("password", $proxyPass);
			}
		} else if ( isset($proxy) ) {
			$proxyconf->removeChild($proxy);
		}
		save_file($config_name,$domdoc->saveXML());
		save_file($proxyFile,$proxydoc->saveXML());
		$reboot=true;
		$reason = "proxy config change (" . ($proxyServer=="" ? "No Proxy" : $proxyServer) . ")";
	}
}
if ($deviceName=="") $deviceName=$serial;
if ($screenId=="") $screenId=$serial;

if ($remoteClientsEnabled=="true") $remoteClientsEnabled=true;
else $remoteClientsEnabled=false;
if ($reboot){

     shutdown($reason);

     if ($pinreset)
		 print("<h3>Modem PIN has been successfully reset</h3>");
	 if ($conf->netiface == ipconfig::NET_MODEM) {
		 print("<h3>3G modem will be used (automatic IP address)</h3>");
	 } elseif ($conf->dhcp) {
		 print("<h3>DHCP will be used on Ethernet.</h3>");
		 $hostname = trim(file_get_contents("/etc/hostname"));
		 print("The unit is always reachable at <a href='http://$hostname.local/'>http://$hostname.local</a> from Zeroconf enabled computers on the local network.");
	 } else  {
		 print("<h3>New ip will be <a href='http://$conf->address/'>$conf->address</a> on Ethernet</h3>");
	 }

}else{
if ($conf->dhcp) $dns->clear();
if ($tabIdx==1) { // normal  
?>
<script type="text/javascript">
<!--
function useDHCP(enabled)
{
	document.getElementsByName("address")[0].disabled=enabled;
	document.getElementsByName("netmask")[0].disabled=enabled;
	document.getElementsByName("gateway")[0].disabled=enabled;
	document.getElementsByName("nameserver1")[0].disabled=enabled;
	document.getElementsByName("nameserver2")[0].disabled=enabled;
	document.getElementsByName("nameserver3")[0].disabled=enabled;
	document.getElementsByName("domain")[0].disabled=enabled;
}
function useIface(iface)
{
	var display_ip;
	var display_modem;
	if (iface == <?php echo '"' . ipconfig::NET_ETHERNET . '"' ?>) {
		display_ip = "";
		display_modem = "none";
	} else {
		display_ip = "none";
		display_modem = "";
	}
	document.getElementById("IpTable").style.display = display_ip;
	document.getElementById("ModemTable").style.display = display_modem;
}
function changeIface()
{
    var selector = document.getElementById("IfaceSelect");
    useIface(selector.options[selector.selectedIndex].value);
}
function configSimple( enabled )
{
	
	for ( var i=0; i<20; i++ ){
		var it = document.getElementById("advanced"+i);
		if ( !it ) break;
		it.style.display=enabled?"none":"";
		it.disabled=enabled;
	}
	for ( var i=0; i<20; i++ ){
		var it = document.getElementById("simple"+i);
		if ( !it ) break;
		it.style.display=enabled?"":"none";
		it.disabled=!enabled;
	}
}
-->
</script>

<h2>Identification: </h2>
<form action="ipconfig.php" method="post">
<table>
<?php
     print("<tr><td>Device name: </td><td><input size='30' type='text' name='deviceName' value=\"".htmlspecialchars($deviceName)."\" /></td></tr>\n");
if (isset($licenses['MULTI']) && $licenses['MULTI']!==false)
     print("<tr><td>Multiscreen ID: </td><td><input size='30' type='text' name='screenId' value=\"". htmlspecialchars($screenId). "\" /></td></tr>\n");
?>
</table>
<input type="submit" value="Apply" name="applyNames"/><br/><br/>

</form>

<h2>Network Settings: </h2>
<form action="ipconfig.php" method="post">

<table id='IfaceTable'>
<?php

print("<tr><td>Use this interface for the network:</td>\n");
print("<td><select name='netiface' id='IfaceSelect' onchange='changeIface()'>\n");
print("<option value='" . ipconfig::NET_ETHERNET . "' " .
	  ($conf->netiface == ipconfig::NET_ETHERNET ? "selected='selected' " : "") .
	  ">Ethernet</option>\n");
print("<option value='" . ipconfig::NET_MODEM . "' " .
	  ($conf->netiface == ipconfig::NET_MODEM ? "selected='selected' " : "") .
	  ">3G Modem</option>\n");
print("</select>\n");
print("</td></tr>\n");

?>
</table>

<?php

print ("<table id='IpTable' " .
	   ($conf->netiface == ipconfig::NET_MODEM ? "style='display: none;'" : "") . ">\n");
print ("<tr><td>DHCP</td><td><input type='radio' name='dhcp' value='1' onclick='useDHCP(true)' ");
if ($conf->dhcp) print ("checked='checked' /> </td></tr>\n");
else print ("/></td></tr>\n");
//print("<tr><td/><td>Hostname:</td><td><input size='30' type='text' name='hostname' value=\"". htmlspecialchars($conf->hostname). "\"/></td></tr>");


print ("<tr><td>Static</td><td><input type='radio' name='dhcp' value='0' onclick='useDHCP(false)' ");
if (!$conf->dhcp) print ("checked='checked' /></td></tr>\n");
else print ("/></td></tr> \n");

if ($conf->dhcp) $disableConf="disabled='disabled' ";
else $disableConf=" ";
print("<tr><td/><td>Address:</td><td><input size='30' type='text' name='address' value=\"". htmlspecialchars($conf->address). "\" $disableConf/> e.g., 192.168.1.10</td></tr>\n");
print("<tr><td/><td>Netmask:</td><td><input size='30' type='text' name='netmask' value=\"". htmlspecialchars($conf->netmask). "\" $disableConf/> e.g., 255.255.255.0</td></tr>\n");
print("<tr><td/><td>Gateway:</td><td><input size='30' type='text' name='gateway' value=\"". htmlspecialchars($conf->gateway). "\" $disableConf/> e.g., 192.168.1.1</td></tr>\n");
print ("<tr><td/><td>DNS:</td></tr>\n");
print("<tr><td/><td>Server 1:</td><td><input size='30' type='text' name='nameserver1' value=\"". htmlspecialchars($dns->nameserver1). "\" $disableConf/> e.g., 192.168.1.1</td></tr>\n");
print("<tr><td/><td>Server 2:</td><td><input size='30' type='text' name='nameserver2' value=\"". htmlspecialchars($dns->nameserver2). "\" $disableConf/> </td></tr>\n");
print("<tr><td/><td>Server 3:</td><td><input size='30' type='text' name='nameserver3' value=\"". htmlspecialchars($dns->nameserver3). "\" $disableConf/> </td></tr>\n");
print("<tr><td/><td>DNS sufix:</td><td><input size='30' type='text' name='domain' value=\"". htmlspecialchars($dns->domain). "\" $disableConf/></td></tr>\n");
print("</table>\n");

print ("<table id='ModemTable' " .
	   ($conf->netiface != ipconfig::NET_MODEM ? "style='display: none;'" : "") . ">\n");
if ($modem->isPINBlocked()) {
print("<tr><td colspan='2'>\n");
print("<b>WARNING</b>: The modem's SIM card is locked because it was initialized with an incorrect PIN too many times. The PIN needs to be reset using the PUK: type in the new PIN along with the PUK in the form below and click apply. Type the PUK carefully as entering an incorrect PUK too many times in a row will permanently lock the SIM card. The PUK is not saved, only the new PIN.\n");
print("</td></tr>");
}

print("<tr valign='baseline'><td>Modem status:</td><td>");
switch ($modem->getStatus()) {
case 'NOT FOUND':
    print("not found"); break;
case 'READY':
    $linktext = 'connect log';
    switch ($modem->getConnectStatus()) {
    case '':
        $linktext = 'previous connect log';
        print("ready"); break;
    case 'ONLINE':
        print("online"); break;
    case 'CONNECTING':
        $linktext = 'previous connect log';
        print("connecting"); break;
    case 'CONNECTED':
        print("connected, intializing link"); break;
    case 'DISCONNECTED':
        print("disconnected"); break;
    case 'IO ERROR':
        print("I/O error while connecting"); break;
    case 'TIMEOUT':
        print("bad command or timeout"); break;
    case 'NETWORK ERROR':
        print("phone network error"); break;
    default:
        print("ready, unknown connection status");
    }
    $connectlog = realpath('../log/modem-connect.log');
    if ($connectlog)
        print(" (<a href='log/modem-connect.log'>" . $linktext . "</a>)");
    break;
case 'PIN INCORRECT':
    print("locked, PIN was incorrect at last boot or modem plug"); break;
case 'PIN':
    print("locked, PIN required"); break;
case 'PUK INCORRECT':
    print("locked, PUK was incorrect, PIN not reset"); break;
case 'PUK':
    print("locked, PUK required"); break;
case 'PIN2':
    print("locked, PIN2 required"); break;
case 'PUK2':
    print("locked, PUK2 required"); break;
case 'ERROR':
    print("initialization failed"); break;
default:
    print("unknown state"); break;
}
print("</td></tr>\n");

$simple=$modem->isSimple();
print("<tr valign='baseline'><td>Configuration type:</td>\n<td>");
print("<input type='radio' name='interfacemode' value='simple' onclick='configSimple(true)' ".($simple?"checked='checked'":"")."/>Simple\n");
print("<input type='radio' name='interfacemode' value='advanced' onclick='configSimple(false)' ".($simple?"":"checked='checked'")."/>Advanced\n</td><tr/>");

$idsimple=0;
$idadvanced=0;
foreach ($modem->getFormNames() as $fname) {
    if ( ! $modem->isFieldActive($fname) )
        continue;
    print("<tr valign='baseline' ");
    if ( $modem->isSimpleOnly($fname) ) 
    	print ("id='simple".($idsimple++)."' ");
    if ( $modem->isAdvancedOnly($fname) ) 
    	print ("id='advanced".($idadvanced++)."' " );
	print("><td>" . ucfirst($modem->getFieldDesc($fname)) . ":</td>");
    print("<td>");
    if ($modem->isChoiceField($fname)) {
        $fval = $modem->getField($fname);
        print("<select name='$fname'>\n");
        foreach ($modem->getFieldChoices($fname) as $fopt) {
            print("<option value=\"" . htmlspecialchars($fopt)) . "\"";
            if ($fval == $fopt)
                print(" selected='selected'");
            print(">" . htmlspecialchars($fopt) . "</option>\n");
        }
        print("</select>\n");
    } else {
        print("<input size='45' type='text' name='$fname' value=\"" .
              htmlspecialchars($modem->getField($fname)) . "\"/> ");
        $fhelp = $modem->getFieldHelp($fname);
        if (isset($fhelp)) {
            print("<br/>\n");
            print($fhelp);
        }
    }
    print("</td></tr>\n");
}
print("<tr><td colspan='2'>\n");
print("The PIN number, if required, is passed to the modem when it is plugged or the HMP reboots. Note that an incorrect PIN will lock the modem, so check it is typed correctly.\n");
print("</td></tr>");
print("<tr><td colspan='2' ");
print("id='advanced".($idadvanced++)."' ".($simple?"style='display: none;' ":""));
print(">\n");
print("The init strings are used to initialize the modem and enter the data communication parameters.\n");
print("To use a specific APN instead of the subscriber's default enter '&nbsp;AT +CGDCONT=<i>&lt;cid&gt;</i>,\"IP\",\"<i>&lt;apn&gt;</i>\"&nbsp;' as an init string, where <i>&lt;cid&gt;</i> is the context ID (usually 1) and <i>&lt;apn&gt;</i> is the desired APN, and enter '&nbsp;*99**1*<i>&lt;cid&gt;</i>#&nbsp;' as the dial string.<br/>\n");
print("</td></tr>\n<tr><td colspan='2' ");
print("id='advanced".($idadvanced++)."' ".($simple?"style='display: none;' ":""));
print(">\n");
print("Contact your telecommunications operator for more details.\n");
print("</td></tr>");
print("</table>\n");
?>
<script language="Javascript">
<!--
function configSimple( enabled )
{
	
	for ( var i=0; i<20; i++ ){
		var it = document.getElementById("advanced"+i);
		if ( !it ) break;
		it.style.display=enabled?"none":"";
	}
	for ( var i=0; i<20; i++ ){
		var it = document.getElementById("simple"+i);
		if ( !it ) break;
		it.style.display=enabled?"":"none";
	}
}

configSimple( <?php if ( $modem->isSimple() ) echo "true"; else echo"false";?> );
-->
</script>
<input type="submit" value="Apply" name="updateNetConf" /><br/><br/>
</form>
<?php
} else { // advanced settings
if (isset($licenses['INTER']) && $licenses['INTER']!==false) {
?>
<h2>Network API:</h2>
<br/>
<form action="ipconfig.php" method="post" >
<input type='checkbox' name='remoteClientsEnabled' <?php if ($remoteClientsEnabled) echo "checked='checked'"; ?> /> 
Enable API server using port : 
<input size='6' type='text' name='sharedVarPort' value="<?php echo htmlspecialchars($sharedVarPort); ?>"/> <br/><br/>
<input type="submit" value="Apply" name="updateAPI"/>
</form><br/>
<?php
}
?>
<h2>Proxy Settings:</h2>
<br/>
<form action="ipconfig.php" method="post" >
<p>
Server: <input size='30' type='text' name='proxyServer' value="<?php echo htmlspecialchars($proxyServer); ?>"/> 
Port: <input size='5' type='text' name='proxyPort' value="<?php echo htmlspecialchars($proxyPort); ?>"/>
</p>
<p>
Username: <input size='15' type='text' name='proxyUser' value="<?php echo htmlspecialchars($proxyUser); ?>"/>
 Password: <input size='15' type='password' name='proxyPass' value="<?php echo htmlspecialchars($proxyPass); ?>"/>
</p>
<p>
<input type='checkbox' name='bypassProxy' <?php if ($bypassProxy) echo "checked='checked'"; ?> /> 
Bypass proxy server for local addresses: 
</p>
<br/>
<input type="submit" value="Apply" name="updateProxy"/>
</form><br/>

<h2>Network Watchdog:</h2>
<br/>
<form action="ipconfig.php" method="post" >
Maximum time the unit may stay without an IP address :  
<input size='6' type='text' name='nwMaxTimeNoAddr' value="<?php echo $nwMaxTimeNoAddr ?>"/>
<br/><br/>
Minimum time an IP address must stay assigned :
<input size='6' type='text' name='nwMinTimeKeepAddr' value="<?php echo $nwMinTimeKeepAddr ?>"/>
<br/><br/>
<p>The unit will be rebooted if the above conditions are not met.
A value of zero disables the condition.
Link-local (i.e. Zeroconf) addresses are not taken into account.</p>
<input type="hidden" value="2" name="tabs"/>
<input type="submit" value="Apply" name="updateNetWatchdog"/>
</form><br/>

<h2>SNMP Settings:</h2>
<br/>
<form action="ipconfig.php" method="post" >
Read only community: <input size='30' type='text' name='rocommunity' value="<?php echo htmlspecialchars($comunity); ?>"/><br/><br/>
Limit acces to SNMP from the network:<br/>
<?php
echo "<table>\n";
echo "<tr><td><input type='radio' name='access' value='local' ".($access=='local'?"checked='checked'":"")."/></td><td>Closed</td></tr>\n";
echo "<tr><td><input type='radio' name='access' value='limited' ".($access=='limited'?"checked='checked'":"")."/></td>";
echo "<td>Open to the following address range:</td></tr>\n";
echo "<tr><td/><td><input size='30' type='text' name='snmpaddress' value='".htmlspecialchars($snmpaddress)."' /><br/>\n";
echo " e.g., 192.168.1.100, 192.168.1.0/24 or 192.168.1.0/255.255.255.0</td></tr>\n";
echo "<tr><td><input type='radio' name='access' value='all' ".($access=='all'?"checked='checked'":"")."/></td><td>Open to everybody</td></tr>\n";
echo "</table>\n";
?>
<input type="hidden" value="2" name="tabs"/>
<input type="submit" value="Apply" name="updateSNMP"/>
</form>
 
<?php
} // advanced settings
} // reboot IP
include "final.php"; 
?>


